!==========================================================
! subroutine for dynamic field memory allocation
!==========================================================

subroutine sec3d_allocate
use parameters
use variables
implicit none
include 'mpif.h'

   !- constitutive parameters

   allocate(rhoinv(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(mu(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(lambda(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(kappa(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(MM(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   if (is_diss==1) then

      allocate(mu_tau(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(tau(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(tau_sp(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

      allocate(Mxx(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(Myy(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(Mzz(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(Mxy(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(Mxz(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(Myz(1:nrdiss,0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   endif

   if (is_aniso==1) then

      allocate(A(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(B(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
      allocate(C(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   endif

   !- dynamic fields

   allocate(ux(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(uy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(uz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   allocate(vx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(vy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(vz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   
   allocate(rotvx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(rotvy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(rotvz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   allocate(sx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   allocate(exx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(eyy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(ezz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(exy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(eyx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(exz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(ezx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(eyz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(ezy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   allocate(sxx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sxy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sxz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   allocate(sxx_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syy_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szz_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sxy_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syx_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sxz_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szx_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(syz_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(szy_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   !allocate(dxux(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dyux(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dzux(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dxuy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dyuy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dzuy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dxuz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dyuz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   !allocate(dzuz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   !- APML variables

   allocate(prof_x(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(prof_y(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(prof_z(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(prof(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(taper(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

   !- geometrical variables

   allocate(x(0:nx,0:lpd))
   allocate(y(0:ny,0:lpd))
   allocate(z(0:nz,0:lpd))
   
   !- source field

   allocate(source_field(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sf_dx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sf_dy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))
   allocate(sf_dz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd))

end subroutine sec3d_allocate



!==========================================================
! subroutine for dynamic field memory deallocation
!==========================================================

subroutine sec3d_deallocate
use parameters
use variables
implicit none
include 'mpif.h'

   !- constitutive parameters

   deallocate(rhoinv)
   deallocate(mu)
   deallocate(lambda)
   deallocate(kappa)
   deallocate(MM)

   if (is_diss==1) then

      deallocate(tau)
      deallocate(mu_tau)
      deallocate(tau_sp)

      deallocate(Mxx)
      deallocate(Myy)
      deallocate(Mzz)
      deallocate(Mxy)
      deallocate(Mxz)
      deallocate(Myz)

   endif

   if (is_aniso==1) then

      deallocate(A)
      deallocate(B)
      deallocate(C)

   endif

   !- dynamic fields

   deallocate(ux)
   deallocate(uy)
   deallocate(uz)

   deallocate(vx)
   deallocate(vy)
   deallocate(vz)

   deallocate(rotvx)
   deallocate(rotvy)
   deallocate(rotvz)
   
   deallocate(sx)
   deallocate(sy)
   deallocate(sz)

   deallocate(exx)
   deallocate(eyy)
   deallocate(ezz)
   deallocate(exy)
   deallocate(eyx)
   deallocate(exz)
   deallocate(ezx)
   deallocate(eyz)
   deallocate(ezy)

   deallocate(sxx)
   deallocate(syy)
   deallocate(szz)
   deallocate(sxy)
   deallocate(syx)
   deallocate(sxz)
   deallocate(szx)
   deallocate(syz)
   deallocate(szy)

   deallocate(sxx_pml)
   deallocate(syy_pml)
   deallocate(szz_pml)
   deallocate(sxy_pml)
   deallocate(syx_pml)
   deallocate(sxz_pml)
   deallocate(szx_pml)
   deallocate(syz_pml)
   deallocate(szy_pml)

   !deallocate(dxux)
   !deallocate(dyux)
   !deallocate(dzux)
   !deallocate(dxuy)
   !deallocate(dyuy)
   !deallocate(dzuy)
   !deallocate(dxuz)
   !deallocate(dyuz)
   !deallocate(dzuz)


   !- APML variables

   deallocate(prof_x)
   deallocate(prof_y)
   deallocate(prof_z)
   deallocate(prof)
   deallocate(taper)

   !- geometrical variables

   deallocate(x)
   deallocate(y)
   deallocate(z)

   !- source field

   deallocate(source_field)
   deallocate(sf_dx)
   deallocate(sf_dy)
   deallocate(sf_dz)

end subroutine sec3d_deallocate
