
subroutine sec3d_evolution
use parameters
use variables
implicit none
include 'mpif.h'

	!======================================================================
	! local variables
	!======================================================================

	integer :: i,j,k,q, in, jn, kn
	real :: body_force, f
	real, dimension(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd) :: L, M_dummy, Mdx, Mdy, Mdz

        real :: dummy_1, dummy_2, dummy_3, dummy

        !======================================================================
        ! computation of strong form strain rates
        !======================================================================

        exx=0.0
        eyy=0.0
        ezz=0.0

        exy=0.0
        exz=0.0
        eyz=0.0

        eyx=0.0
        ezx=0.0
        ezy=0.0

        sxx=0.0
        syx=0.0
        szx=0.0

        sxy=0.0
        syy=0.0
        szy=0.0

        sxz=0.0
        syz=0.0
        szz=0.0


        do i=0,lpd
           do q=0,lpd

              dummy_1=2*dl(q,i)/dx
              dummy_2=2*dl(q,i)/dy
              dummy_3=-2*dl(q,i)/dz

              !- velocity derivatives ----------------------------------------------
              
              exx(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=exx(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +vx(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              eyy(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=eyy(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +vy(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              ezz(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=ezz(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +vz(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3

              
              exy(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=exy(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +vy(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              eyx(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=eyx(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +vx(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              exz(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=exz(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +vz(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              ezx(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=ezx(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +vx(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3

              eyz(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=eyz(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +vz(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              ezy(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=ezy(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +vy(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3
					     

              !- displacement derivatives ---------------------------------------------

              sxx(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=sxx(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +ux(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              syy(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=syy(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +uy(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              szz(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=szz(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +uz(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3

              
              sxy(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=sxy(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +uy(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              syx(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=syx(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +ux(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              sxz(0:nx,0:ny,0:nz,i,0:lpd,0:lpd)=sxz(0:nx,0:ny,0:nz,i,0:lpd,0:lpd) &
                                               +uz(0:nx,0:ny,0:nz,q,0:lpd,0:lpd)*dummy_1

              szx(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=szx(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +ux(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3

              syz(0:nx,0:ny,0:nz,0:lpd,i,0:lpd)=syz(0:nx,0:ny,0:nz,0:lpd,i,0:lpd) &
                                               +uz(0:nx,0:ny,0:nz,0:lpd,q,0:lpd)*dummy_2

              szy(0:nx,0:ny,0:nz,0:lpd,0:lpd,i)=szy(0:nx,0:ny,0:nz,0:lpd,0:lpd,i) &
                                               +uy(0:nx,0:ny,0:nz,0:lpd,0:lpd,q)*dummy_3

           enddo
        enddo
        
	!=================================================================================
        ! save forward fields 
	!=================================================================================

!                if ((mod(it,samp_ad)==0) .or. (it==1) .or. (it==nt)) then


!			if ((iy_multi>1) .and. (iy_multi<py)) then 

 !	                      call sec3d_store(0.5*(sxy+syx),'sxy',it,lpd,1010)
!			      call sec3d_store(0.5*(sxz+szx),'sxz',it,lpd,1011)
!			      call sec3d_store(0.5*(syz+szy),'syz',it,lpd,1012)
			      
!			      call sec3d_store(sxx,'sxx',it,lpd,1013)
!		      	      call sec3d_store(syy,'syy',it,lpd,1014)
!			      call sec3d_store(szz,'szz',it,lpd,1015)

!			      saving_vector(it)=it

!			endif

!		endif
                           
        !==================================================================================
        ! rotations
        !==================================================================================

        rotvx=syz-szy
        rotvy=szx-sxz
        rotvz=sxy-syx

	!===================================================================================
	! pml strains
	!===================================================================================
                                                   
        exx=exx+(prof_z+prof_y)*sxx
        eyy=eyy+(prof_x+prof_z)*syy
        ezz=ezz+(prof_x+prof_y)*szz
        
        exy=exy+(prof_y+prof_z)*sxy
        eyx=eyx+(prof_x+prof_z)*syx
        
        exz=exz+(prof_y+prof_z)*sxz
        ezx=ezx+(prof_x+prof_y)*szx
        
        eyz=eyz+(prof_x+prof_z)*syz
        ezy=ezy+(prof_x+prof_y)*szy
        
	!======================================================================
	! make strong form stress rates
	!======================================================================
	
        ! - diagonal stresses -------------------------------------------------

        
        if (is_diss==1) then

           Mdx=0.0
           Mdy=0.0
           Mdz=0.0

           do k=1,nrdiss

              Mdx=Mdx+Mxx(k,:,:,:,:,:,:)
              Mdy=Mdy+Myy(k,:,:,:,:,:,:)
              Mdz=Mdz+Mzz(k,:,:,:,:,:,:)

           enddo

           M_dummy=Mdx+Mdy+Mdz

           L=(kappa-2*mu_tau/3)*(exx+eyy+ezz)-2*mu*M_dummy/3

           sxx=L+2*(mu_tau*exx+mu*Mdx)
           syy=L+2*(mu_tau*eyy+mu*Mdy)
           szz=L+2*(mu_tau*ezz+mu*Mdz)
              
        else

           L=lambda*(exx+eyy+ezz)

           sxx=L+2*mu*exx
           syy=L+2*mu*eyy
           szz=L+2*mu*ezz

        endif

	!- off-diagonal stresses ----------------------------------------------
		
        if (is_diss==1) then

           Mdx=0.0
           Mdy=0.0
           Mdz=0.0
           
           do k=1,nrdiss

              Mdx=Mdx+Mxy(k,:,:,:,:,:,:)
              Mdy=Mdy+Mxz(k,:,:,:,:,:,:)
              Mdz=Mdz+Myz(k,:,:,:,:,:,:)

           enddo

	   sxy=mu_tau*(exy+eyx)+2*mu*Mdx
	   	
	   sxz=mu_tau*(exz+ezx)+2*mu*Mdy

	   syz=mu_tau*(eyz+ezy)+2*mu*Mdz

        else

           sxy=mu*(exy+eyx)
           sxz=mu*(exz+ezx)
           syz=mu*(eyz+ezy)

        endif

        !======================================================================
        ! time stepping of strong pml stresses
        !======================================================================

        sxx_pml=sxx_pml+dt*(sxx-prof_x*sxx_pml)
        syy_pml=syy_pml+dt*(syy-prof_y*syy_pml)
        szz_pml=szz_pml+dt*(szz-prof_z*szz_pml)

        sxy_pml=sxy_pml+dt*(sxy-prof_x*sxy_pml)
        syx_pml=syx_pml+dt*(sxy-prof_y*syx_pml)

        sxz_pml=sxz_pml+dt*(sxz-prof_x*sxz_pml)
        szx_pml=szx_pml+dt*(sxz-prof_z*szx_pml)

        syz_pml=syz_pml+dt*(syz-prof_y*syz_pml)
        szy_pml=szy_pml+dt*(syz-prof_z*szy_pml)
	
        !======================================================================
        ! add moment tensor source
        !======================================================================
        
!        if (source_type==10) then

!                sxx_pml(isx,isy,isz,isx_n,isy_n,isz_n)=sxx_pml(isx,isy,isz,isx_n,isy_n,isz_n)+MOMxx*so(it)/Jac
!                        *sf_dx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)
!                syy_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=syy_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)+MOMyy*so(it) &
!                        *source_field(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)
!                szz_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=szz_pml(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)+MOMzz*so(it) &
!                        *source_field(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)

!        endif
        
	!======================================================================
	! make weak form stresses = accelerations
	!======================================================================

	sx=0.0
	sy=0.0
	sz=0.0

	!----------------------------------------------------------------------
	
	do i=0,lpd
	do j=0,lpd
	do k=0,lpd

        dummy_1=(2/dx)*Jac*w(j)*w(k)
        dummy_2=(2/dy)*Jac*w(i)*w(k)
        dummy_3=-(2/dz)*Jac*w(i)*w(j)

	do q=0,lpd

	sx(0:nx,0:ny,0:nz,i,j,k)=sx(0:nx,0:ny,0:nz,i,j,k) &
                                +w(q)*sxx_pml(0:nx,0:ny,0:nz,q,j,k)*dl(i,q)*dummy_1 &
				+w(q)*syx_pml(0:nx,0:ny,0:nz,i,q,k)*dl(j,q)*dummy_2 &
				+w(q)*szx_pml(0:nx,0:ny,0:nz,i,j,q)*dl(k,q)*dummy_3      
	
	sy(0:nx,0:ny,0:nz,i,j,k)=sy(0:nx,0:ny,0:nz,i,j,k) &
                                +w(q)*sxy_pml(0:nx,0:ny,0:nz,q,j,k)*dl(i,q)*dummy_1 &
				+w(q)*syy_pml(0:nx,0:ny,0:nz,i,q,k)*dl(j,q)*dummy_2 &
				+w(q)*szy_pml(0:nx,0:ny,0:nz,i,j,q)*dl(k,q)*dummy_3      
	
	sz(0:nx,0:ny,0:nz,i,j,k)=sz(0:nx,0:ny,0:nz,i,j,k) &
                                +w(q)*sxz_pml(0:nx,0:ny,0:nz,q,j,k)*dl(i,q)*dummy_1 &
				+w(q)*syz_pml(0:nx,0:ny,0:nz,i,q,k)*dl(j,q)*dummy_2 &
				+w(q)*szz_pml(0:nx,0:ny,0:nz,i,j,q)*dl(k,q)*dummy_3      
				
	enddo

	enddo
	enddo
	enddo

        !======================================================================
        ! globalisation of local stresses
        !======================================================================

        call comm_S(sx,sy,sz)

	!======================================================================
	! add external body forces
	!======================================================================
	
	! Hier m�sste man noch garantieren, dass die Kräfte auch an den doppelten Gitterpunkten ordentlich implementiert sind.
	
	if (is_source>0) then
		
                body_force=so(it)
    
		if (source_type==1) then
			sx(isx,isy,isz,isx_n,isy_n,isz_n)=sx(isx,isy,isz,isx_n,isy_n,isz_n)-body_force
		elseif (source_type==2) then
			sy(isx,isy,isz,isx_n,isy_n,isz_n)=sy(isx,isy,isz,isx_n,isy_n,isz_n)-body_force
		elseif (source_type==3) then
			sz(isx,isy,isz,isx_n,isy_n,isz_n)=sz(isx,isy,isz,isx_n,isy_n,isz_n)-body_force
               endif
		
	endif

        if ((is_source>0) .and. (source_type==10)) then

                sx=sx+(sf_dx*MOMxx+sf_dy*MOMxy+sf_dz*MOMxz)*so(it)
                sy=sy+(sf_dy*MOMyy+sf_dx*MOMxy+sf_dz*MOMyz)*so(it)
                sz=sz+(sf_dz*MOMzz+sf_dy*MOMyz+sf_dx*MOMxz)*so(it)

        endif

        !======================================================================
        ! make accelerations / divide weak stresses by mass matrix
        !======================================================================

        sx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=-sx(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)/MM(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)
        sy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=-sy(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)/MM(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)
        sz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=-sz(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)/MM(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)
        
	!======================================================================
	! time extrapolation of the displacement field
	!======================================================================

        vx=vx+dt*(sx-prof*vx)
        vy=vy+dt*(sy-prof*vy)
        vz=vz+dt*(sz-prof*vz)

        ux=ux+dt*vx
        uy=uy+dt*vy
        uz=uz+dt*vz

        !======================================================================
        ! time extrapolation of memory variables
        !======================================================================

        if (is_diss==1) then

           do k=1,nrdiss

              L=dt*tau/(nrdiss*tau_sp(k,:,:,:,:,:,:))

              Mxx(k,:,:,:,:,:,:)=Mxx(k,:,:,:,:,:,:)-dt*Mxx(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*exx

              Myy(k,:,:,:,:,:,:)=Myy(k,:,:,:,:,:,:)-dt*Myy(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*eyy

              Mzz(k,:,:,:,:,:,:)=Mzz(k,:,:,:,:,:,:)-dt*Mzz(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*ezz
              
              Mxy(k,:,:,:,:,:,:)=Mxy(k,:,:,:,:,:,:)-dt*Mxy(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*(exy+eyx)/2
              
              Mxz(k,:,:,:,:,:,:)=Mxz(k,:,:,:,:,:,:)-dt*Mxz(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*(exz+ezx)/2
              
              Myz(k,:,:,:,:,:,:)=Myz(k,:,:,:,:,:,:)-dt*Myz(k,:,:,:,:,:,:)/tau_sp(k,:,:,:,:,:,:) &
                                -L*(eyz+ezy)/2

           enddo

        endif

        !=======================================================================
        ! compute kinetic energy density
        !=======================================================================

        E_kin=0.0
        L=(vx*vx+vy*vy+vz*vz)
        L(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)=L(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)/rhoinv(0:nx,0:ny,0:nz,0:lpd,0:lpd,0:lpd)

        do i=0,nx
           do j=0,ny
              do k=0,nz

                 do in=0,lpd
                    do jn=0,lpd
                       do kn=0,lpd

                          E_kin=E_kin+L(i,j,k,in,jn,kn)*w(in)*w(jn)*w(kn)

                       enddo
                    enddo
                 enddo

              enddo
           enddo
        enddo

        E_kin=0.5*E_kin*Jac

		
!	if ((it>200) .and. (E_kin>1.01*E_kin_old)) then
	
           ux=ux*taper
           uy=uy*taper
           uz=uz*taper

           vx=vx*taper
           vy=vy*taper
           vz=vz*taper

           sxx_pml=sxx_pml*taper
           syy_pml=syy_pml*taper
           szz_pml=szz_pml*taper
           
           sxy_pml=sxy_pml*taper
           syx_pml=syx_pml*taper

           szx_pml=szx_pml*taper
           sxz_pml=sxz_pml*taper

           syz_pml=syz_pml*taper
           szy_pml=szy_pml*taper

!	endif
	   
        E_kin_old=E_kin
           

end subroutine sec3d_evolution
