
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% setup
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x=-1.0:0.0001:1.0;                % coordinates
n=7;                            % Lagrange polynomial index
lpd=6;                          % Lagrange polynomial degree

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% initialise collocation points
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

knots=0*(1:8);

if (lpd==2)
		
		knots(1)=-1.0;
		knots(2)=0.0;
		knots(3)=1.0;
		
elseif (lpd==3)
		
		knots(1)=-1.0;
		knots(2)=-0.4472135954999579;
		knots(3)=0.4472135954999579;
		knots(4)=1.0;
		
elseif (lpd==4)
		
		knots(1)=-1.0;
		knots(2)=-0.6546536707079772;
		knots(3)=0.0;
		knots(4)=0.6546536707079772;
		knots(5)=1.0;
		
elseif (lpd==5)
		
		knots(1)=-1.0;
		knots(2)=-0.7650553239294647;
		knots(3)=-0.2852315164806451;
		knots(4)=0.2852315164806451;
		knots(5)=0.7650553239294647;
		knots(6)=1.0;
		
elseif (lpd==6)
		
		knots(1)=-1.0;
		knots(2)=-0.8302238962785670;
		knots(3)=-0.4688487934707142;
		knots(4)=0.0;
		knots(5)=0.4688487934707142;
		knots(6)=0.8302238962785670;
		knots(7)=1.0;
		
elseif (lpd==7)
		
		knots(1)=-1.0;
		knots(2)=-0.8717401485096066;
		knots(3)=-0.5917001814331423;
		knots(4)=-0.2092992179024789;
		knots(5)=0.2092992179024789;
		knots(6)=0.5917001814331423;
		knots(7)=0.8717401485096066;
		knots(8)=1.0;
        
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% make Lagrange polynomials
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lp=ones(1,length(x));

for k=1:lpd+1
    
    if (k~=n)
    
        lp=lp.*(x-knots(k))/(knots(n)-knots(k));
        
    end
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% derivative of Lagrange polynomials
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dlp=ones(1,length(x));
dx=x(2)-x(1);

for k=2:length(x)-1
    
    dlp(k)=(lp(k+1)-lp(k-1))/(2*dx);
    
end

dlp(1)=dlp(2);
dlp(end)=dlp(end-1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot output
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure
plot(x,lp,'k');
grid on
hold on
axis([min(x) max(x) -1.2 1.2]);

for k=1:lpd+1
    plot([knots(k) knots(k)],[-1.0 1.0]);
end

figure
plot(x,dlp,'k');
grid on
hold on
axis([min(x) max(x) -max(abs(dlp)) max(abs(dlp))]);

for k=1:lpd+1
    plot([knots(k) knots(k)],[-max(abs(dlp)) max(abs(dlp))]);
end