% make adjoint sources for rotation and amplitude kernels
% w=rotation
% s=displacement
% t=time axis

bndry_left=210;
bndry_right=220;

dt=t(2)-t(1);

%-----------------------------------------------------------------------------
%- amplitude adjoint stf -----------------------------------------------------
%-----------------------------------------------------------------------------

if (1==0) 

vx=diff(sx)/dt;
vx(end+1)=0.0;
vz=diff(sz)/dt;
vz(end+1)=0.0;

tvx=taper(vx,t,bndry_left,bndry_right,5);
tvz=taper(vz,t,bndry_left,bndry_right,5);

Av=sqrt(sum(tvx.*tvx+tvz.*tvz)*dt);

tvx=1e9*tvx/(Av*Av);
tvz=1e9*tvz/(Av*Av);

adsx=diff(tvx)/dt;
adsx(end+1)=0.0;

adsz=diff(tvz)/dt;
adsz(end+1)=0.0;

iv=length(t):-1:1;
adsx=adsx(iv);
adsz=adsz(iv);

fid_y=fopen('ad_src_y_1','w');
fid_x=fopen('ad_src_x_1','w');
fid_z=fopen('ad_src_z_1','w');

for k=1:length(t)
	fprintf(fid_y,'%g\n',0.0);
	fprintf(fid_x,'%g\n',adsx(k));
	fprintf(fid_z,'%g\n',adsz(k));
end

fclose(fid_x);
fclose(fid_y);
fclose(fid_z); 

end

%---------------------------------------------------------------------------------
%- rotation adjoint stf
%---------------------------------------------------------------------------------

if (1==1)

w=w/2;
tw=taper(w,t,bndry_left,bndry_right,5);
Aw=sqrt(sum(tw.*tw)*dt);
tw=1e9*tw/(2*Aw*Aw);

iv=length(t):-1:1;
ads=tw(iv);

fid_y=fopen('ad_src_y_1','w');
fid_x=fopen('ad_src_x_1','w');
fid_z=fopen('ad_src_z_1','w');

for k=1:length(t)
	fprintf(fid_y,'%g\n',ads(k));
	fprintf(fid_x,'%g\n',0.0);
	fprintf(fid_z,'%g\n',0.0);
end

fclose(fid_x);
fclose(fid_y);
fclose(fid_z);

end
