%==========================================================================
% read boxfile
%==========================================================================

figure

fpt=fopen('../MODELS/boxfile','r');

for i=1:14
    fgets(fpt);
end

p.pp=fscanf(fpt,'%i',1);
p.px=fscanf(fpt,'%i',1);
p.py=fscanf(fpt,'%i',1);
p.pz=fscanf(fpt,'%i',1);

fgets(fpt);
fgets(fpt);

p.mi=[1:p.pp];
p.mi_theta=[1:p.pp];
p.mi_phi=[1:p.pp];
p.mi_r=[1:p.pp];

p.itheta_min=[1:p.pp];
p.itheta_max=[1:p.pp];
p.iphi_min=[1:p.pp];
p.iphi_max=[1:p.pp];
p.ir_min=[1:p.pp];
p.ir_max=[1:p.pp];

p.theta_min=[1:p.pp];
p.theta_max=[1:p.pp];
p.phi_min=[1:p.pp];
p.phi_max=[1:p.pp];
p.r_min=[1:p.pp];
p.r_max=[1:p.pp];

for i=1:p.pp
    
    p.mi(i)=fscanf(fpt,'%d',1);
    p.mi_theta(i)=fscanf(fpt,'%d',1);
    p.mi_phi(i)=fscanf(fpt,'%d',1);
    p.mi_z(i)=fscanf(fpt,'%d',1);
    p.itheta_min(i)=fscanf(fpt,'%i',1);
    p.itheta_max(i)=fscanf(fpt,'%i',1);
    p.iphi_min(i)=fscanf(fpt,'%i',1);
    p.iphi_max(i)=fscanf(fpt,'%i',1);
    p.ir_min(i)=fscanf(fpt,'%i',1);
    p.ir_max(i)=fscanf(fpt,'%i',1);
    
    p.theta_min(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.theta_max(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.phi_min(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.phi_max(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.r_min(i)=fscanf(fpt,'%lf',1);
    p.r_max(i)=fscanf(fpt,'%lf',1);
    
    fgets(fpt);
    fgets(fpt);
    
end

fclose(fpt);

%==========================================================================
% determine filename
%==========================================================================

n=input('processor: ');
plane=input('plane (theta, phi, r): ','s');
comp=input('component (1, 2, 3): ', 's');
it=input('iteration: ');

filename=['../DATA/OUTPUT/grad' comp '_' plane 'plane' num2str(n) '_' num2str(it)];
fpt=fopen(filename,'r');

fprintf(1,'opening file %s\n',filename);

if (strcmp(plane,'theta'))
    
    theta=input('theta in deg: ');
    theta=theta*pi/180;
    field=zeros(p.iphi_max(n+1)-p.iphi_min(n+1)+1,p.ir_max(n+1)-p.ir_min(n+1)+1);
    
    for k=0:1:p.ir_max(n+1)-p.ir_min(n+1)
        for j=0:1:p.iphi_max(n+1)-p.iphi_min(n+1)
            field(j+1,k+1)=fscanf(fpt,'%lf',1);
            %fprintf(1,'.',1);
        end
    end
    
    dphi=(p.phi_max(n+1)-p.phi_min(n+1))/(p.iphi_max(n+1)-p.iphi_min(n+1));
    dr=(p.r_max(n+1)-p.r_min(n+1))/(p.ir_max(n+1)-p.ir_min(n+1));
    phi=p.phi_min(n+1):dphi:p.phi_max(n+1);
    r=p.r_max(n+1):-dr:p.r_min(n+1);
    [phi,r]=meshgrid(phi,r);
    
    y=r.*sin(phi)*sin(theta);
    x=r.*cos(phi)*sin(theta);
    
    pcolor(y,x,field')
    
end

if (strcmp(plane,'phi'))
    
    %phi=input('phi in deg: ');
    %phi=phi*pi/180;
    field=zeros(p.itheta_max(n+1)-p.itheta_min(n+1)+1,p.ir_max(n+1)-p.ir_min(n+1)+1);
 
    for k=0:1:p.ir_max(n+1)-p.ir_min(n+1)
        for i=0:1:p.itheta_max(n+1)-p.itheta_min(n+1)
            field(i+1,k+1)=fscanf(fpt,'%lf',1);
            %fprintf(1,'.',1);
        end
    end
    
    dtheta=(p.theta_max(n+1)-p.theta_min(n+1))/(p.itheta_max(n+1)-p.itheta_min(n+1));
    dr=(p.r_max(n+1)-p.r_min(n+1))/(p.ir_max(n+1)-p.ir_min(n+1));
    theta=p.theta_min(n+1):dtheta:p.theta_max(n+1);
    r=p.r_max(n+1):-dr:p.r_min(n+1);
    [theta,r]=meshgrid(theta,r);
    
    y=r.*cos(theta);
    x=r.*sin(theta);
    
    pcolor(y,x,field')
    
end

if (strcmp(plane,'r'))
    
    r=input('r in m: ');
    field=zeros(p.itheta_max(n+1)-p.itheta_min(n+1)+1,p.iphi_max(n+1)-p.iphi_min(n+1)+1);
    
    for j=0:1:p.iphi_max(n+1)-p.iphi_min(n+1)
        for i=0:1:p.itheta_max(n+1)-p.itheta_min(n+1)
            field(i+1,j+1)=fscanf(fpt,'%lf',1);
            %fprintf(1,'.',1);
        end
    end
    
    dphi=(p.phi_max(n+1)-p.phi_min(n+1))/(p.iphi_max(n+1)-p.iphi_min(n+1));
    dtheta=(p.theta_max(n+1)-p.theta_min(n+1))/(p.itheta_max(n+1)-p.itheta_min(n+1));
    
    phi=p.phi_min(n+1):dphi:p.phi_max(n+1);
    theta=p.theta_min(n+1):dtheta:p.theta_max(n+1);
    
    [theta,phi]=meshgrid(theta,phi);
    x=r*cos(phi).*sin(theta);
    y=r*sin(phi).*sin(theta);
    
    pcolor(180*phi/pi,180*theta/pi,field')
    
end


fclose(fpt);