%==========================================================================
% read boxfile
%==========================================================================

cut=0.0e-4;

figure

fpt=fopen('../MODELS/boxfile','r');

for i=1:14
    fgets(fpt);
end

p.pp=fscanf(fpt,'%i',1);
p.px=fscanf(fpt,'%i',1);
p.py=fscanf(fpt,'%i',1);
p.pz=fscanf(fpt,'%i',1);

fgets(fpt);
fgets(fpt);

p.mi=[1:p.pp];
p.mi_theta=[1:p.pp];
p.mi_phi=[1:p.pp];
p.mi_r=[1:p.pp];

p.itheta_min=[1:p.pp];
p.itheta_max=[1:p.pp];
p.iphi_min=[1:p.pp];
p.iphi_max=[1:p.pp];
p.ir_min=[1:p.pp];
p.ir_max=[1:p.pp];

p.theta_min=[1:p.pp];
p.theta_max=[1:p.pp];
p.phi_min=[1:p.pp];
p.phi_max=[1:p.pp];
p.r_min=[1:p.pp];
p.r_max=[1:p.pp];

for i=1:p.pp
    
    p.mi(i)=fscanf(fpt,'%d',1);
    p.mi_theta(i)=fscanf(fpt,'%d',1);
    p.mi_phi(i)=fscanf(fpt,'%d',1);
    p.mi_z(i)=fscanf(fpt,'%d',1);
    p.itheta_min(i)=fscanf(fpt,'%i',1);
    p.itheta_max(i)=fscanf(fpt,'%i',1);
    p.iphi_min(i)=fscanf(fpt,'%i',1);
    p.iphi_max(i)=fscanf(fpt,'%i',1);
    p.ir_min(i)=fscanf(fpt,'%i',1);
    p.ir_max(i)=fscanf(fpt,'%i',1);
    
    p.theta_min(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.theta_max(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.phi_min(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.phi_max(i)=fscanf(fpt,'%lf',1)*pi/180;
    p.r_min(i)=fscanf(fpt,'%lf',1);
    p.r_max(i)=fscanf(fpt,'%lf',1);
    
    fgets(fpt);
    fgets(fpt);
    
end

fclose(fpt);

%==========================================================================
% determine filename
%==========================================================================

n=input('processor vector: ');
plane=input('plane (x, y, z): ','s');
comp=input('component (x, y, z): ', 's');
it=input('iteration: ');

%==========================================================================
% successively open files
%==========================================================================

for index=1:length(n)

   filename=['../DATA/OUTPUT/slice_' plane '_u' comp '_' num2str(n(index)) '_' num2str(it)];
   fpt=fopen(filename,'r');

   fprintf(1,'opening file %s\n',filename);

   %==========================================================================
   % load coordinate lines
   %==========================================================================

   filename_xco=['../DATA/COORDINATES/xco_' num2str(n(index))];
   filename_yco=['../DATA/COORDINATES/yco_' num2str(n(index))];
   filename_zco=['../DATA/COORDINATES/zco_' num2str(n(index))];

   fid_xco=fopen(filename_xco,'r');
   fid_yco=fopen(filename_yco,'r');
   fid_zco=fopen(filename_zco,'r');

   xco=fscanf(fid_xco,'%f',inf);
   yco=fscanf(fid_yco,'%f',inf);
   zco=fscanf(fid_zco,'%f',inf);

   if (index==1)

      x_min=min(xco);
      x_max=max(xco);
      y_min=min(yco);
      y_max=max(yco);
      z_min=min(zco);
      z_max=max(zco);

   else

      if (min(xco)<x_min) x_min=min(xco); end
      if (max(xco)>x_max) x_max=max(xco); end
      if (min(yco)<y_min) y_min=min(yco); end
      if (max(yco)>y_max) y_max=max(yco); end
      if (min(zco)<z_min) z_min=min(zco); end
      if (max(zco)>z_max) z_max=max(zco); end

   end

   fclose(fid_xco);
   fclose(fid_yco);
   fclose(fid_zco);

   %==========================================================================
   % read and plot fields
   %==========================================================================

   if (strcmp(plane,'x'))
    
       field=zeros(length(yco),length(zco));
    
       for k=1:length(zco)
           for j=1:length(yco)
               field(j,k)=fscanf(fpt,'%f',1);
           end
       end
    
       field=field.*(abs(field)>cut);

       [yco,zco]=meshgrid(yco,zco);
       pcolor(yco,zco,field');
       hold on
      
       xlabel('y [m]');
       ylabel('z [m]');
       axis([y_min y_max z_min z_max]);
    
   end

   if (strcmp(plane,'y'))
    
       field=zeros(length(xco),length(zco));
    
       for k=1:length(zco)
           for i=1:length(xco)
               field(i,k)=fscanf(fpt,'%f',1);
           end
       end
    
       field=field.*(abs(field)>cut);

       [xco,zco]=meshgrid(xco,zco);
       pcolor(xco,zco,field');
       hold on    

       xlabel('x [m]');
       ylabel('z [m]');
       axis([x_min x_max z_min z_max]);
    
   end

   if (strcmp(plane,'z'))
    
       field=zeros(length(xco),length(yco));
    
       for j=1:length(yco)
           for i=1:length(xco)
               field(i,j)=fscanf(fpt,'%f',1);
           end
       end

       field=field.*(abs(field)>cut);
    
       [xco,yco]=meshgrid(xco,yco);
       pcolor(xco,yco,field');
       hold on
    
       xlabel('x [m]');
       ylabel('y [m]');
       axis([x_min x_max y_min y_max]);
    
   end

   fclose(fpt);

end

axis image