

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% M-file for the generation of source time functions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% last modified: 6 November 2006

fprintf(1,'\nwavelet parameters:\n');
wavelet=input('wavelet: Gauss=1, d/dt Gauss=2,  Ricker=3, Dirac=4: ');

t_0=input('t_0: ');
d_t=input('d_t: ');
n_t=input('n_t: ');
amp=input('maximum amplitude: ');

t=t_0:d_t:n_t*d_t;

if (wavelet==1)

  t_s=input('t_s: ');
  t_p=input('t_p: ');

  f=amp*exp(-(t-t_p).*(t-t_p)/(t_s*t_s));

  w=(-10/t_s):(1/(4*t_s)):(10/t_s);

  s=t_s*sqrt(pi)*exp(-0.25*w.*w.*t_s*t_s);

elseif (wavelet==2)

  t_s=input('t_s: ');
  t_p=input('t_p: ');

  f=-2*(t-t_p).*exp(-(t-t_p).*(t-t_p)/(t_s*t_s))/(t_s*t_s);

  %f=f/(max(abs(f)));
  f=amp*f;

  w_dom=sqrt(2)/t_s;
  w=-4*w_dom:(w_dom/10):4*w_dom;

  fprintf(1,'dominant frequency: %g Hz\n',w_dom/(2*pi));
  fprintf(1,'dominant period: %g s\n',2*pi/w_dom);

  s=w.*t_s.*sqrt(pi).*exp(-0.25*w.*w.*t_s*t_s);

elseif (wavelet==3)

  t_s=input('t_s: ');
  t_p=input('t_p: ');

  f=-2*exp(-(t-t_p).*(t-t_p)/(t_s*t_s))/(t_s*t_s)+4*(t-t_p).*(t-t_p).*exp(-(t-t_p).*(t-t_p)/(t_s*t_s))/(t_s*t_s*t_s*t_s);

  %f=f/(max(abs(f)));
  f=amp*f;

  w_dom=sqrt(8)/t_s;
  w=-4*w_dom:(w_dom/10):4*w_dom;

  fprintf(1,'dominant frequency: %g Hz\n',w_dom/(2*pi));
  fprintf(1,'dominant period: %g s\n',2*pi/w_dom);

  s=w.*w.*t_s.*sqrt(pi).*exp(-0.25*w.*w.*t_s*t_s);

elseif (wavelet==4)

  f=zeros(1,length(t));
  f(1)=amp;

  w=-1:0.01:1;
  s=ones(1,length(w));

end
  

% plot signal and spectrum

figure
subplot(2,1,1)
plot(t,f,'k');
xlabel('t in s');
title('wavelet, time domain');

subplot(2,1,2)
plot(w/(2*pi),s,'k');
xlabel('\nu in Hz');
title('wavelet, frequency domain');


fid=fopen('../MODELS/stf','w');

for k=1:length(t)
    fprintf(fid,'%g\n',f(k));
end

fclose(fid);
